%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Ori_vector = Get_Shell_Orientation_Vector(Element_ID)

% Принадлежность элемента к типу Quad или Tria должна проверяться вне данной функции до ее вызова
% Существование элемента Element_ID должно проверяться вне данной функции до ее вызова
% Наличие непустой ссылки на property set у элемента Element_ID должно проверяться вне данной функции до ее вызова
% Принадлежность property set элемента к необходимому типу должна проверяться вне данной функции до ее вызова

global DB_NODES;
global DB_ELEMENTS;
global DB_COORD;

global AT_NODES;
global AT_ELEMENTS;
global AT_COORD;

[Ori_type, Ori_data] = Get_Shell_Orientation(Element_ID);

switch DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.N_nodes

    case {3,6}
        
        if (Ori_type == 0)
            
            Point_1 = DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(1))}.Location;
            Point_2 = DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(2))}.Location;
            Point_3 = DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(3))}.Location;
            
            Plane_normal = cross(Point_2-Point_1, Point_3-Point_1);
            Plane_normal = Plane_normal / norm(Plane_normal);
            
            if (Ori_data == 0)
                Direction_Vector = [1;0;0];
            else
                Direction_Vector = DB_COORD{AT_COORD(Ori_data)}.e_x;
            end
            
            Ori_vector = Direction_Vector - dot(Direction_Vector, Plane_normal) * Plane_normal;
            Ori_vector = Ori_vector / norm(Ori_vector);
            
        else
            
            Vector_1 = DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(2))}.Location - DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(1))}.Location;
            Vector_2 = DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(3))}.Location - DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(1))}.Location;
            
            Vector_3 = cross(Vector_1,Vector_2);
            Vector_2 = cross(Vector_3,Vector_1);
            
            Vector_1 = Vector_1 / norm(Vector_1);
            Vector_2 = Vector_2 / norm(Vector_2);
            
            Ori_vector = cosd(Ori_data)*Vector_1 + sind(Ori_data)*Vector_2;
            Ori_vector = Ori_vector / norm(Ori_vector);
            
        end

    case {4,8}
        
        if (Ori_type == 0)
            
            Point_1 = DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(1))}.Location;
            Point_2 = DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(2))}.Location;
            Point_3 = (DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(3))}.Location + DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(4))}.Location)/2;
            
            Plane_normal = cross(Point_2-Point_1, Point_3-Point_1);
            Plane_normal = Plane_normal / norm(Plane_normal);
            
            if (Ori_data == 0)
                Direction_Vector = [1;0;0];
            else
                Direction_Vector = DB_COORD{AT_COORD(Ori_data)}.e_x;
            end
            
            Ori_vector = Direction_Vector - dot(Direction_Vector, Plane_normal) * Plane_normal;
            Ori_vector = Ori_vector / norm(Ori_vector);
            
        else
            
            Vector_1 = DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(2))}.Location - DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(1))}.Location;
            Midpoint = (DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(3))}.Location + DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(4))}.Location)/2;
            Vector_2 = Midpoint - DB_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(1))}.Location;
            
            Vector_3 = cross(Vector_1,Vector_2);
            Vector_2 = cross(Vector_3,Vector_1);
            
            Vector_1 = Vector_1 / norm(Vector_1);
            Vector_2 = Vector_2 / norm(Vector_2);
            
            Ori_vector = cosd(Ori_data)*Vector_1 + sind(Ori_data)*Vector_2;
            Ori_vector = Ori_vector / norm(Ori_vector);
            
        end

end
